#include<stdio.h>
#include<stdlib.h>
#include<dos.h>
#include<ctype.h>
#include<string.h>
#include<math.h>

// AOS include files
#include "main.h"

// Apparently you can get the com port addresses from the following locations...
// COM1 = 0x00000400
// COM2 = 0x00000402
// COM3 = 0x00000404
// COM4 = 0x00000406
// I am told it is POSSIBLE that the addresses be different (IBM PS/2)
// The hard-coding is ok for 99.999% of machines.

/* COM Port Addresses (COM1-COM4) (A dummy value for COM0) */
int COM[5]={0x0000,0x03F8,0x02F8,0x03E8,0x02E8};

void ReadyCOM(int num)
{
  int SpeedDiv=(115200/nLCDBaud);
  outp(COM[num] + 3, inp(COM[num] + 3) | 0x080);
  outp(COM[num],  SpeedDiv & 0x0FF);
  outp(COM[num] + 1, SpeedDiv >> 8);
  outp(COM[num] + 3, inp(COM[num] + 3) & 0x07F);
  outp(COM[num] + 4, inp(COM[num] + 4) | 0x003);
}

void WriteChar(int num,char ch)
{
  outp(COM[num],ch);
  while ((inp(COM[num] + 5) & 0x020) == 0);
}

void mssleep(int ms)
{
   struct time t;
   long int starttime;

   gettime(&t);
   starttime=
     t.ti_hour *10000000
     +t.ti_min *100000
     +t.ti_sec *1000
     +t.ti_hund*10
     ;

   do
     gettime(&t);
   while(
     (t.ti_hour*10000000
     +t.ti_min *100000
     +t.ti_sec *1000
     +t.ti_hund*10)
     -starttime<ms
   );
}

void WriteCOM(int num,char *str)
{
  char *ptr,*ptr2;
  for(ptr=str;*ptr!='\0';ptr++)
    {
      if(*ptr=='<')
        {
          // if the next char is the same...just add one!
          if(*(ptr+1)=='<')
            {
              /* We want an actual < character */
              WriteChar(num,'<');
              ptr++;
            }
          else
            {
              /* Decode escape sequence... */
              ptr2=strchr(ptr,'>');
              if(ptr2)
                {
                  if(!strnicmp(ptr+1,"CTRL-",5))
                    WriteChar(num,toupper(*(ptr+6))-'A'+1);
                  else if(!strnicmp(ptr+1,"CTRL",4))
                    WriteChar(num,toupper(*(ptr+5))-'A'+1);
                  else if(!strnicmp(ptr+1,"CR",2))
                    WriteChar(num,'\r');
                  else if(!strnicmp(ptr+1,"LF",2))
                    WriteChar(num,'\n');
                  else if(!strnicmp(ptr+1,"PAUSE-",6))
                    mssleep(atoi(ptr+7)?atoi(ptr+7):500);
                  else if(!strnicmp(ptr+1,"PAUSE",5))
                    mssleep(atoi(ptr+6)?atoi(ptr+6):500);
                  else
                    WriteChar(num,atoi(ptr+1)&0xFF);
                  ptr=ptr2;
                }
              else		// Add it like a plain char!
                WriteChar(num,'<');
            }
        }
      else		// It's just another plain character to output.
        WriteChar(num,*ptr);
    }
}

////////////////////////////////////////////////
// Below this line, specifically for ArcadeOS //
////////////////////////////////////////////////

void displayLCDLogo(void)
{
  FILE *fp;
  char buf[4096];


  if((!bLCDScreen)||(!nLCDSerialPort)||(!Emulators[CurEmu].szLCDLogo))
    return;

  fp=fopen(Emulators[CurEmu].szLCDLogo,"r");
  if(!fp)
    fp=fopen(Emulators[EMU_MAME].szLCDLogo,"r");
  if(!fp)
    fp=fopen("aos.lcd","r");

  if(fp)
    {
      ReadyCOM(nLCDSerialPort);
      while(fgets(buf,4096,fp))
        {
          if(strchr(buf,'\r'))
            *strchr(buf,'\r')='\0';
          if(strchr(buf,'\n'))
            *strchr(buf,'\n')='\0';
          if(strlen(buf)>0)
            WriteCOM(nLCDSerialPort,buf);
        }
      fclose(fp);
    }
}

void displayLCDGameInfo(char *GameName)
{
  FILE *fp;
  char buf[4096];

  if((!bLCDScreen)||(!nLCDSerialPort)||(!Emulators[CurEmu].szLCDPath))
    return;

  strcpy(buf,Emulators[CurEmu].szLCDPath);
  if(buf[strlen(buf)-1]!='\\')
    strcat(buf,"\\");
  strcat(buf,GameName);
  strcat(buf,".lcd");

  fp=fopen(buf,"r");
  if(fp)
    {
      ReadyCOM(nLCDSerialPort);
      loginfo(1,"Displaying LCD file \"%s\".",buf);
      while(fgets(buf,4096,fp))
        {
          if(strchr(buf,'\r'))
            *strchr(buf,'\r')='\0';
          if(strchr(buf,'\n'))
            *strchr(buf,'\n')='\0';
          if(strlen(buf)>0)
            WriteCOM(nLCDSerialPort,buf);
        }
      fclose(fp);
    }
  else
    loginfo(1,"Could not open LCD file \"%s\".",buf);
}

void displayLCDShutdown(void)
{
  FILE *fp;
  char buf[4096];

  if((!bLCDScreen)||(!nLCDSerialPort)||(!szLCDShutdown))
    return;

  fp=fopen(szLCDShutdown,"r");
  if(fp)
    {
      ReadyCOM(nLCDSerialPort);
      loginfo(1,"Displaying LCD shutdown file.");
      while(fgets(buf,4096,fp))
        {
          if(strchr(buf,'\r'))
            *strchr(buf,'\r')='\0';
          if(strchr(buf,'\n'))
            *strchr(buf,'\n')='\0';
          if(strlen(buf)>0)
            WriteCOM(nLCDSerialPort,buf);
        }
      fclose(fp);
    }
}



